unit ctrlsform;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_controls, dx_textbox, dx_objects, dx_ani,
  dx_vgcore, dx_vglayer;

type
  TfrmCtrlsDemo = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Light1: TdxLight;
    Camera1: TdxCamera;
    dxBitmapList1: TdxBitmapList;
    cameraRot: TdxFloatAnimation;
    GuiLayer: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Text3D1: TdxText3D;
    FloatAnimation1: TdxFloatAnimation;
    ScaleTrack: TvxTrackBar;
    ControlRoot: TvxLayout;
    ScaleRoot: TvxLayout;
    ScrollBox1: TvxScrollBox;
    ToolbarLayer: TdxGUIObjectLayer;
    Root3: TvxLayout;
    ToolBar2: TvxToolBar;
    opacityBar: TvxCompoundTrackBar;
    rotateBar: TvxCompoundAngleBar;
    depthBar: TvxCompoundTrackBar;
    StylePopup: TvxPopupBox;
    Label18: TvxLabel;
    modernStyle: TvxResources;
    airStyle: TvxResources;
    vistaStyle: TvxResources;
    ValueLabel1: TvxValueLabel;
    ListTransform: TvxStringListBox;
    TrackBar2: TvxTrackBar;
    TrackBar3: TvxTrackBar;
    TextBox4: TvxTextBox;
    PathCheckBox1: TvxPathCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ScaleTrackChange(Sender: TObject);
    procedure opacityBarChange(Sender: TObject);
    procedure rotateBarChange(Sender: TObject);
    procedure depthBarChange(Sender: TObject);
    procedure StylePopupChange(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCtrlsDemo: TfrmCtrlsDemo;

implementation

{$R *.dfm}

procedure TfrmCtrlsDemo.FormCreate(Sender: TObject);
var
  i: integer;
begin
  inherited;
  for i := 0 to 50 do
    with TvxRectangle.Create(Self) do
    begin
      parent := ScrollBox1;
      width := (30 + random(150));
      height := (30 + random(150));
      hittest := false;
      Position.x := random(1300);
      Position.y := random(1300);
      xRadius := random(20);
      yRadius := xRadius;
      hitTest := false;
      fill.SolidColor := ((50 + random(205)) shl 24) or random($FFFFFF);
    end;
end;

procedure TfrmCtrlsDemo.ScaleTrackChange(Sender: TObject);
begin
  ControlRoot.Scale.Point := vgPoint(ScaleTrack.Value / 100, ScaleTrack.Value / 100);
end;

procedure TfrmCtrlsDemo.opacityBarChange(Sender: TObject);
begin
  GuiLayer.Opacity := opacityBar.Value;
end;

procedure TfrmCtrlsDemo.rotateBarChange(Sender: TObject);
begin
  GuiLayer.RotateAngle.Y := rotateBar.Value;
end;

procedure TfrmCtrlsDemo.depthBarChange(Sender: TObject);
begin
  GuiLayer.Position.Z := depthBar.Value;
end;

procedure TfrmCtrlsDemo.StylePopupChange(Sender: TObject);
begin
  case StylePopup.ItemIndex of
    0: GuiLayer.Style := nil;
    1: GuiLayer.Style := modernStyle;
    2: GuiLayer.Style := vistaStyle;
    3: GuiLayer.Style := airStyle;
  end;
end;

procedure TfrmCtrlsDemo.TrackBar2Change(Sender: TObject);
begin
  ListTransform.RotateAngle := TrackBar2.Value;
  TextBox4.RotateAngle := TrackBar2.Value;
end;

procedure TfrmCtrlsDemo.TrackBar3Change(Sender: TObject);
begin
  ListTransform.Opacity := TrackBar3.Value;
  TextBox4.Opacity := TrackBar3.Value;
end;

end.
